
import java.io.*;
import java.net.Socket;

/********************************************************************
http_handler svolge varie funzioni:
consente la lettura di dati da uno stream in una volta sola
consente la lettura di dati da uno stream "a blocchi" di dimensione
scelta dall'utente
interpreta una risposta di un server GFG1.0 restituendone i campi
consente la creazione di pacchetti di richiesta HTTP-UDP 1.0 e HTTP-TCP 1.0
******************************************************************/

public class http_handler
{
  public static final String UDP_STRING="HTTP-UDP/1.0";
  public static final String TCP_STRING="HTTP-TCP/1.0";
  public static final String PROTOCOL_STRING="P/1.0";
  
  public String header;
  public int RECEIVE_BUFFER;//ampiezza del buffer di ricezione
  public String msg;//contenuto del messaggio se testuale
  public byte bytes[];//contenuto del messaggio se binario
  public boolean inbytes;//messaggio binario o testuale?
  public int size;
  public boolean more;//segue un altro blocco?
  public String type;//stringa che identifica il tipo di dati nel messaggio
  public String return_code;//codice di ritorno del server
    public boolean authoritative;//risulta da una connessione reale?
    boolean len_is_valid=false;
    int len=0;
  private InputStream in ;
  public static boolean verbose=false;
  private int remember_pos;
  Socket socket;//necessario per una corretta chiusura del socket
  
  /**chiude lo stream dati*/
  public void shutdown()
    { try{if (verbose) System.out.println(" HH USER REQUEST:closing sock in TcpCl2...");socket.close(); }
    catch(IOException ioe) {if (verbose) System.out.println("HH Can't close!!!!!!");}}
  
  /**costruttore che NON assegna uno stream (read proibita)**/
  http_handler() 
    {authoritative=false;inbytes=false;size=0; msg="";more=false;
    return_code="ERROR";}
  /**costruttore che assegna lo stream, consente read**/     
  http_handler(InputStream is,int RB) 
    {in=is; RECEIVE_BUFFER=RB;authoritative=false;}
  
  /** funzione ausiliaria che estrae la prima riga contenente la
stringa passata come parametro**/
  String estrai_voce(String nome)
    {
      if (verbose) System.out.println("Inizia estrai voce <"+nome+">");
      int i=header.lastIndexOf(nome);
      if (verbose) System.out.println("i="+i);
      if (i<0||i>=header.length()) return "";
      String rest=header.substring(i+nome.length());
      //if (verbose) System.out.println("rest=<"+rest+">");
      rest.trim();
      int j=0;
      while (j++<=rest.length())
	{
	  if (rest.charAt(j)=='\n') break;
	}
      //if (j>=rest.length()) return "";
      if (verbose) System.out.println("j="+j+" fine estrai voce");
      return rest.substring(0,j);
    }
  
  /**funzione che costruisce un pacchetto richiesta compatibile 
     con HTTP-UDP1.0 e HTTP-TCP1.0*/
    static String pacchetto_richiesta(String addr,String protocol,String metodo,String sender)
    {
	String version="UNKNOWN";
	String method,p;
	protocol=protocol.toUpperCase();/* System.out.println("prot="+protocol);*/
	if (protocol.compareTo("UDP")==0) version=UDP_STRING;
	if (protocol.compareTo("TCP")==0) version=TCP_STRING;
	
	metodo=metodo.toUpperCase();										  
	if (metodo.compareTo("POST")==0) method="POST";
	else method="GET";
	
      
	p=method+" "+addr+" "+version+" \r\nUser-Agent: GFGC 0.9\r\nHost: "+sender+"\r\nAccept:\r\n\r\n";
	
	
	/*	if (verbose) System.out.println("\n richiesta p="+p);*/
	
	return p;
    }//pacch rich





  
    /** consente la lettura del successivo blocco dati (non del primo) e 
	eventualmente chiude lo stream se il blocco  l'ultimo*/
    public void reRead() throws IOException
    {
	more=false;	
	if (verbose) System.out.println("Inizio RIlettura:");
	byte buf[]=new byte[RECEIVE_BUFFER];
	int c;
	int counter=0;
	int pos=remember_pos;
	if (verbose) System.out.println("\n ReREAD START\n");
	
	while (true)
	    {
		if ((c=in.read())==-1)
		    {
			if (verbose) System.out.print("ReRead: esco per EOB!!");
			more=false;
			break;
		    }
		if (verbose) System.out.print(((char)c));
		
		buf[counter]=(byte) c;
		if (verbose) System.out.println(" byte["+counter+"]="+buf[counter]+" pos="+pos);
		
		pos++;counter++;
		if (counter>=RECEIVE_BUFFER&&len_is_valid&&pos<=len) 
		    {
			if (verbose) System.out.println(" httphnd ESCO per rec buf");	
			more=true; break;
 
		    }
		
		else {/*in.close();*/}
		if (len_is_valid&&pos>len) 
		    {
			if (verbose)  System.out.println("REhttphandler break CL");
			more=false;
			break;
		    }
	    }
	if (verbose) System.out.println("\n ReREAD ENDS\n");
	
	remember_pos=pos;
	/** estrazione del contenuto vero e proprio */
	if (type.startsWith("text/plain"))
	    {inbytes=false; 
	    
	    msg=new String(buf,0,counter);
	    
	    if (verbose) System.out.println("TcpCl2: msg="+msg);
	    }		
	
	else
	    {
		inbytes=true; 
		bytes=new byte[counter];
		for (int j=0;j<counter;j++) bytes[j]=buf[j];
		if (verbose) System.out.println("nbytes="+(counter)+" in char="+(new String(bytes)));
		
	    }
	if (verbose) System.out.println(" inbytes="+inbytes);
    }//reRead
    










    /** legge il primo (o l'unico) blocco dati dello stream, occupandosi
	dell'interpretazione dell'header e del settaggio dei campi di http_handler**/
    void read() throws IOException
    {
	if (verbose) System.out.println("BUFFER="+RECEIVE_BUFFER);
	more=false;
	if (verbose) System.out.println("Inizio lettura:");
	byte buf[]=new byte[RECEIVE_BUFFER];
	int fine_header=0;
	int pos=0;
	int c;
	if (verbose) System.out.println("\n *****READ START\n");
	
	
	
	while (((c=in.read())!=-1))
	    {
		
		if (verbose) {System.out.print(((char)c));}
		
		buf[pos]=(byte) c;
if (verbose)		System.out.println(" byte["+pos+"]="+buf[pos]+" ");
		
		if ((pos>=3)&&(buf[pos-1]=='\r')&&(buf[pos]=='\n')&&(buf[pos-3]=='\r')&&(buf[pos-2]=='\n'))
		    {if (verbose) System.out.println("header ends at "+pos);
		    fine_header=pos;
		    
		    header=new String(buf,0,pos);
		    if (verbose) System.out.println("header = "+header+" \nfine header");
		//      String lgs=(estrai_voce("content-length:")).trim();
//  		    int lg=(new Integer(lgs)).intValue();
//  		    len_is_valid=true;
		    //    if (verbose) System.out.println("HHTTTPP :LEN="+lg);
		    //len=lg;
		    }
		pos++;
		if (pos>=RECEIVE_BUFFER)//&&len_is_valid&&pos<len) 
		    {
			more=true; 
			if (verbose) System.out.println("httphandler MORE DATA!!");
			break;
		    }
		
		//if (len_is_valid&&pos>=len) 
		//  {
		//if (verbose)  System.out.println("httphandler break CL");
		//more=false;
		//break;
		//  }
	    }
if (verbose)	System.out.println("\n *****READ END\n");
	
	
	remember_pos=pos;
	header=header.toLowerCase();
	if (verbose) System.out.println("Fine lettura pos="+pos);
	
	if (verbose) System.out.println("header LC=<"+header+">");
	/* parsing dei campi informativi*/
	String lgs=(estrai_voce("content-length:")).trim();
	int lg=(new Integer(lgs)).intValue();
	if (lg>0) 
	    {
		len_is_valid=true;
		len=lg+header.length();
		if (verbose) System.out.println("len valid, len="+len);
	    }	
	int 	temppos=fine_header+1+lg;
	if (temppos<RECEIVE_BUFFER) pos=temppos;
	else pos=RECEIVE_BUFFER-1;
	//if (verbose) System.out.println("content=<"+(new String(buf,fine_header+1,pos))+">");
	
	type=(estrai_voce("content-type:")).trim();
	if (verbose) System.out.println(" type="+type);
		
	
	if (verbose) System.out.println(" lg="+lg+" pos="+pos);
	return_code=(estrai_voce(PROTOCOL_STRING.toLowerCase())).trim();
	if (verbose) System.out.println(" code="+return_code);
	
	
	
	/** estrazione del contenuto vero e proprio */
	if (type.startsWith("text/plain"))
	    {inbytes=false; 
	    if (verbose) System.out.println("httphnd finehead="+fine_header+" pos="+pos+" bufl="+buf.length); 
	    
	    msg=new String(buf,fine_header+1,pos-fine_header/*-1**22:12MODIF***/);
	    if (verbose) System.out.println("httphnd: msg="+msg);
	    }		
	
	else
	    {
		inbytes=true; 
		bytes=new byte[pos-fine_header/*-1**22:33 modif*/];
		for (int j=0;j<bytes.length;j++) bytes[j]=buf[fine_header+1+j];
		if (verbose) System.out.println("nbytes="+(pos-fine_header+1)+" in char="+(new String(bytes)));
		
	    }
	if (verbose) System.out.println(" inbytes="+inbytes);
	
    }//read

}//fine classe














