
import java.awt.geom.AffineTransform;
import java.awt.*;
import java.awt.image.*;

import java.awt.event.*;
import java.util.Vector;
import puppet;
/*******************************************************************************************
gestisce il display per visualizzare un vettore di immagini (gestite singolarmente da puppet.java)
creando una finestra atta alla visualizzazione.
Contiene l'implementazione di un ImageObserver**/

/*** implementa un ImageObserver che disegna l'immagine man mano che i dati vengono passati*/
class myIObs extends Component implements ImageObserver 
{
  boolean error;
  public boolean imageUpdate(Image img,int flags,int x,int y,int w,int h)
    {
      if ((flags&SOMEBITS)!=0) 
	{
	  repaint(x,y,w,h);
	}
      else if ((flags&ABORT)!=0) {error=true; repaint();}
      return (flags&(ALLBITS|ABORT))==0;
    }
  
}


/** visualizza una finestra in cui pu allocare un vettore di immagini**/
public class imager extends Frame {
  
  static boolean verbose=false;
  Canvas canva=new Canvas();
  
  Graphics2D g2;
  int X,Y;
  Vector ps;	
  
  public void addPuppet(int i,puppet p)
    {if (verbose) p.verbose=true; ps.add(i,p); }
  public void removePuppet(puppet p)
    { ps.removeElement(p);}
  public void removePuppet(int i) {ps.removeElementAt(i);}
  
  
  public void setPuppetXY(puppet p,int x,int y)
    { int j=ps.indexOf(p);
    ((puppet) ps.elementAt(j)).x=x;
    ((puppet) ps.elementAt(j)).y=y;
	}
  public void setPuppetXY(int j,int x,int y)
    { 
      ((puppet) ps.elementAt(j)).x=x;
	((puppet) ps.elementAt(j)).y=y;
    }
  
  
  imager(int nX,int nY,String tt) {
    
    addWindowListener(
		      new WindowAdapter() {
        public void windowClosing(WindowEvent e){
          if (verbose) System.out.println("Window Closing");
	  //          System.exit(0);
	  dispose();
        }
    });
    X=nX;
    Y=nY;
    setTitle(tt);
    ps=new Vector();
    setLayout(new FlowLayout());
    add(canva);
    adjust();  
  }
  
  /** ridefiniamo paint per ottenere la visualizzazione delle immagini**/
  public void paint(Graphics h)
    {
      for (int i=0;i<ps.size();i++)
	{
	  puppet p=(puppet) ps.elementAt(i);
	  myIObs obs=new myIObs();
	  
	  g2.drawImage( p.img, new AffineTransform(), obs) ;
	}
    }
  
  /** sposta i componenti e setta le loro dimensioni**/
  public void adjust()
    {
      
      setSize(X,Y);
      setVisible(true);
      canva.setSize(X,Y);
      canva.setLocation(0,0);
      canva.setBackground(Color.black);
      g2=(Graphics2D) canva.getGraphics();

    }
  
  
  public static void main(String[] args) {
    
    String title="imager";
    
    imager f=new imager(500,500,title);
    puppet p=new puppet("dragon.jpg",0,0);
    f.addPuppet(0,p);
    f.setTitle(title);
    
    
  }
} 


